<?php
/**
 * Fonctions utiles au plugin GamuMail
 *
 * @plugin     GamuMail
 * @copyright  2020
 * @author     tofulm
 * @licence    GNU/GPL
 * @package    SPIP\Gamumail\Fonctions
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

function gamumail_TabClient($objet, $id_objet, $champ){
	return compact('objet', 'id_objet', 'champ');
}


/**
 * modèles pour surcharge des fonctions du CVT gamumail
 * chacune de ces fonctions a un équivalent spécifique pour chaque slug
 * avec un nom de la forme gamumail_$slug_charger(), gamumail_$slug_verifier()...
 **/

/**
 * fonction appelée en fin de gamumail_charger_dist()
 *
 * $valeurs = array(
 * 	"slug"         => $slug,
 * 	'sujet'        => $gamuMail['sujet'],
 * 	'texte'        => $gamuMail['texte'],
 * 	'pour'         => implode(',', $Tmails),
 * 	'cc'           => lire_config('gamumail/mail_cc'),
 * 	'cci'          => lire_config('gamumail/mail_cci'),
 * 	'TFichierpdfs' => $TFichierPdf,
 * 	'Tpdfs_ok'     => [],
 * 	'Tid_doc'      => [],
 * 	'options'      => $options
 * );
 * 
 * @return array $valeurs
 * 
 **/
function gamumail_charger_dist($valeurs, $options, $slug, $auteur, $Tclient, $Tpdf, $redirect) {
	
	return $valeurs;
}

/**
 * fonction appelée en fin de gamumail_verifier_dist()
 * 
 * @return array $erreurs
 * 
 **/
function gamumail_verifier_dist($erreurs, $options, $slug, $auteur, $Tclient, $Tpdf, $redirect) {
	
	return $erreurs;
}

/**
 * fonctions appelée en fin de gamumail_traiter_dist()
 * 
 * @param string $slug modele du mail a charger
 * @param int|string $auteur  id_auteur ou email du destinataire
 * @param array $Tclient [] ['objet' => 'app_client', 'id_objet' => 3, 'champ' => 'email'] ou  ['objet' => 'app_client', 'id_objet' => 3, 'champ' => 'email']
 * @param array $Tpdf [] ['fichier' => 'pdf_facture', 'nom' => 'facture_123', 'contexte' => ['id_app_facture' => 3]] ou ['fichier' => 'pdf_facture', 'nom' => 'facture_123', 'contexte' => ['id_app_facture' => 3]]
 * @param string $redirect
 * @param array $options
 * 
 * @return array $corps 
 *	$corps = [
 *		'html'  => $html,
 *		'texte' => $texte,
 *		'cc'    => $cc,
 *		'cci'   => $cci
 *	];
 * 
 **/
function gamumail_traiter_dist($corps, $options, $slug, $auteur, $Tclient, $Tpdf, $redirect) {

	$html = $corps['html'];
	$html = str_replace('@@truc_a_remplacer@@', 'le machin qui remplace', $html);
	include_spip('classes/facteur');
	$texte  = facteur_mail_html2text($html);
	$corps['html'] = $html;
	$corps['texte'] = $texte;

	return $corps;
}
